package huang.inequalitiesSolver;
public class Edge {

	private Variable starter;
	private double a;
	private Variable ender;
	private double b;
	private double c; // a*starter+b*ender<=c

	public Edge(Variable starter, double a, Variable ender, double b, double c) {
		this.starter = starter;
		this.a = a;
		this.ender = ender;
		this.b = b;
		this.c = c;
	}
	
	public Edge(Variable starter, double a, double c){
		this.starter = starter;
		this.a = a;
		this.c = c;
		this.ender = starter;
		this.b=0;
	}
	


	public Variable getStarter() {
		return starter;
	}

	public double getA() {
		return a;
	}

	public Variable getEnder() {
		return ender;
	}

	public double getB() {
		return b;
	}

	public double getC() {
		return c;
	}
	
	public void setEnder(Variable v){
		ender = v;
	}

	public Edge elimination(int i, Edge e) {
		Edge edge;
		switch (i) {
		case 1: {
			double ratio = -e.getA() / a;
			double a1 = b * ratio;
			double b1 = e.getB();
			double c1 = c * ratio + e.getC();
			edge = new Edge(ender, a1, e.getEnder(), b1, c1);
		}
			break;
		case 3: {
			double ratio = -e.getA() / b;
			double a1 = a * ratio;
			double b1 = e.getB();
			double c1 = c * ratio + e.getC();
			edge = new Edge(ender, a1, e.getEnder(), b1, c1);
		}
			break;
		case 5: {
			double ratio = -e.getB() / a;
			double a1 = e.getA();
			double b1 = b * ratio;
			double c1 = c * ratio + e.getC();
			edge = new Edge(ender, a1, e.getEnder(), b1, c1);
		}
		case 7: {
			double ratio = -e.getB() / b;
			double a1 = a * ratio;
			double b1 = e.getA();
			double c1 = c * ratio + e.getC();
			edge = new Edge(ender, a1, e.getEnder(), b1, c1);

		}
		default:
			edge = null;
		}
		return edge;
	}

	public boolean restrictSolution(int i, Edge e) {
		boolean t;
		switch (i) {
		case 9: {
			System.out.println(toString()+"\n" + e.toString());
			double ratio = -e.getA() / a;
			if ((b * ratio + e.getB()) == 0) {
				if ((c * ratio + e.getC()) >= 0)
					return true;
				else
					return false;
			}

			else if ((b * ratio + e.getB()) < 0) {
				double min = (c * ratio + e.getC()) / (b * ratio + e.getB());
				t = ender.setMin(min);
				if (t == false)
					return t;
			} else {
				double max = (c * ratio + e.getC()) / (b * ratio + e.getB());
				t = ender.setMax(max);
				if (t == false)
					return t;
			}

			double ratio2 = -e.getB() / b;
			if ((a * ratio2 + e.getA()) == 0) {
				if ((c * ratio2 + e.getC()) >= 0)
					return true;
				else
					return false;
			}

			else if ((a * ratio2 + e.getA()) < 0) {
				double min = (c * ratio2 + e.getC()) / (a * ratio2 + e.getA());
				t = starter.setMin(min);
				return t;
			} else {
				double max = (c * ratio2 + e.getC()) / (a * ratio2 + e.getA());
				t = starter.setMax(max);
				return t;
			}
		}
		
		case 11: { //need to be modified
			System.out.println(toString()+"\n" + e.toString());
			double ratio = -e.getA() / b;
			if ((a * ratio + e.getB()) == 0) {
				if ((c * ratio + e.getC()) >= 0)
					return true;
				else
					return false;
			}

			else if ((a * ratio + e.getB()) < 0) {
				double min = (c * ratio + e.getC()) / (a * ratio + e.getB());
				t = starter.setMin(min);
				if (t == false)
					return t;
			} else {
				double max = (c * ratio + e.getC()) / (a * ratio + e.getB());
				t = starter.setMax(max);
				if (t == false)
					return t;
			}

			double ratio2 = -e.getB() / a;
			if ((b * ratio2 + e.getA()) == 0) {
				if ((c * ratio2 + e.getC()) >= 0)
					return true;
				else
					return false;
			}

			else if ((b * ratio2 + e.getA()) < 0) {
				double min = (c * ratio2 + e.getC()) / (b * ratio2 + e.getA());
				t = ender.setMin(min);
				return t;
			} else {
				double max = (c * ratio2 + e.getC()) / (b * ratio2 + e.getA());
				t = ender.setMax(max);
				return t;
			}
		}
		
		case 10: {
			System.out.println(toString()+"\n" + e.toString());
			if(this.a*e.getA()<0){
				double ratio = -e.getA()/a;
				if(b*ratio+e.getB()<0){
					double min = (c * ratio + e.getC()) / (b * ratio + e.getB());
					return ender.setMin(min);
				}
				if(b*ratio+e.getB()>0){
					double max = (c * ratio + e.getC()) / (b * ratio + e.getB());
					return ender.setMax(max);
				}
				
			}
			else{
				double ratio = -e.getB()/b;
				if(a*ratio+e.getA()<0){
					double min = (c * ratio + e.getC()) / (a * ratio + e.getA());
					return starter.setMin(min);
				}
					if(a*ratio+e.getA()>0){
					double max = (c * ratio + e.getC()) / (a * ratio + e.getA());
					return starter.setMax(max);
				}
			}
		}
		
		case 12: {
			System.out.println(toString()+"\n" + e.toString());
			if(this.a*e.getB()<0){
				double ratio = -e.getB()/a;
				if(e.getA()+b*ratio<0){
					double min = (c * ratio + e.getC()) / (b * ratio + e.getA());
					return ender.setMin(min);
				}
				if(e.getA()+b*ratio>0){
					double max = (c * ratio + e.getC()) / (b * ratio + e.getA());
					return ender.setMax(max);
				}
				
			}
			if(this.b*e.getA()<0){
				double ratio = -e.getA()/b;
				if(e.getB()+a*ratio<0){
					double min = (c * ratio + e.getC()) / (a * ratio + e.getB());
					return starter.setMin(min);
				}
				if(e.getB()+a*ratio>0){
					double max = (c * ratio + e.getC()) / (a * ratio + e.getB());
					return starter.setMax(max);
				}
				
			}
		}
		
		case 100: return true;

		}
		return false;
	}

	public int variablesUnion(Edge e) {
	//	if(e.getEnder()== null && e.getStarter().equals(starter)) e.setEnder(ender);
	//	if(e.getEnder()== null && e.getStarter().equals(ender)) e.setEnder(starter);
	//	if(ender == null && e.getStarter().equals(starter)) setEnder(e.getEnder());
	//	if(ender == null && e.getEnder().equals(starter)) setEnder(e.getStarter());

		if (e.getStarter().equals(this.starter)
				&& !e.getEnder().equals(this.ender) && (e.getA() * this.a) < 0)
			return 1;
		// if(e.getStarter().equals(this.starter)&&
		// !e.getEnder().equals(this.ender)&& (e.getA()*this.a)==0) return 2;
		if (e.getStarter().equals(this.ender)
				&& !e.getEnder().equals(this.starter)
				&& (e.getA() * this.b) < 0)
			return 3;
		// if(e.getStarter().equals(this.ender)&&
		// !e.getEnder().equals(this.starter)&& (e.getA()*this.b)==0) return 4;
		if (e.getEnder().equals(this.starter)
				&& !e.getStarter().equals(this.ender)
				&& (e.getB() * this.a) < 0)
			return 5;
		// if(e.getEnder().equals(this.starter)&&
		// !e.getStarter().equals(this.ender)&& (e.getB()*this.a)==0) return 6;
		if (e.getEnder().equals(this.ender)
				&& !e.getStarter().equals(this.starter)
				&& (e.getB() * this.b) < 0)
			return 7;
		// if(e.getEnder().equals(this.ender)&&
		// !e.getStarter().equals(this.starter)&& (e.getB()*this.b)==0) return
		// 8;
		if (e.getStarter().equals(this.starter)
				&& e.getEnder().equals(this.ender) && (e.getA() * this.a) < 0
				&& (e.getB() * this.b) < 0)
			return 9;
		if (e.getStarter().equals(this.starter)
				&& e.getEnder().equals(this.ender)
				&& ((e.getA() * this.a) < 0 || (e.getB() * this.b) < 0))
			return 10;
		if (e.getStarter().equals(this.ender)
				&& e.getEnder().equals(this.starter) && (e.getA() * this.b) < 0
				&& (e.getB() * this.a) < 0)
			return 11;
		if (e.getStarter().equals(this.ender)
				&& e.getEnder().equals(this.starter)
				&& ((e.getA() * this.b) < 0 || (e.getB() * this.a) < 0))
			return 12;
		else	return 100;
	}
	
	public void setC(double d){
		c=d;
	}
	
	public String toString(){
		String s = "Edge is: \n";
		if(b<0) s+= a+ "v"+ getStarter().getID()+ " " + b + "v"+ getEnder().getID()+ " <= " + getC()+ "\n";
		else s+= getA()+ " v"+ getStarter().getID()+ " +" + getB() + "v"+ getEnder().getID()+ " <= " + getC()+"\n";
		return s;
	}

}
