package huang.inequalitiesSolver;

import java.util.*;

public class Solver {

	private Problem problem;
	boolean isWrongProblem = false;

	public Solver() {
		problem = new Problem();
	}

	public void loadProblem(String fileName) {
		ReadInInequalities in = new ReadInInequalities(fileName);
		problem = in.getProblem();
		if (in.getIsWrongProblem() == true)
			isWrongProblem = true;
	}

	public void loadProblem() {
		Variable v1 = new Variable(1);
		Variable v2 = new Variable(2);
		// Edge e1 = new Edge(v1, 6,);
		Edge e2 = new Edge(v1, -6, v2, -5, 9);
		Edge e3 = new Edge(v2, 8, v1, 1, 1);
		Edge e4 = new Edge(v1, -9, v2, -6, 19);
		Edge e5 = new Edge(v1, 0, v2, 3, -2);
		Edge e6 = new Edge(v1, 8, v2, 0, -7);
		Edge e7 = new Edge(v1, 8, v1, 0, -7);
		Edge e8 = new Edge(v1, 8, v2, 0, -7);
		Edge e9 = new Edge(v1, -6, v2, -5, 9);
		Edge e10 = new Edge(v1, 3, v2, 100, -77);
		Edge e11 = new Edge(v1, 1, v2, 0, -0.876);
		Edge e12 = new Edge(v1, 0, v2, 1, -1.1);
		Edge e13 = new Edge(v1, 0, v2, -1, 3);
		problem.addEdge(e13);
		 problem.addEdge(e12);
		problem.addEdge(e11);
		problem.addEdge(e10);
		// problem.addEdge(e1);
		problem.addEdge(e2);
		problem.addEdge(e3);
		problem.addEdge(e4);
		problem.addEdge(e5);
		problem.addEdge(e6);
		problem.addEdge(e7);
		problem.addEdge(e8);
		problem.addEdge(e9);

	}

	public ArrayList<double[]> run(String fileName) {
		ArrayList<double[]> results = new ArrayList<double[]>();
		loadProblem(fileName);
		if (isWrongProblem == true) {
			System.out.println("There is no solution for the equation group!");
			return results;
		} else {
			System.out.println(problem.printProblem());
			if (problem.solve() == false) {
				System.out
						.println("There is no solution for the equation group!");
				return results;
			} else {
				for (Variable v : problem.getVariables()) {
					double[] result = new double[3];
					result[0] = v.getID();
					result[1] = v.getMin();
					result[2] = v.getMax();
					results.add(result);
				}
				System.out.println(problem.printSolution());
				return results;
			}
		}
	}
}

/*
 * public static void main(String args[]) { Solver s = new Solver();
 * s.loadProblem(("Inequalities3")); System.out.println("There are " +
 * s.problem.getVariables().size() + " variables."); if (s.isWrongProblem ==
 * true) System.out.println("There is no solution for the equation group!");
 * else { // s.loadProblem(); System.out.println(s.problem.printProblem()); if
 * (s.problem.solve() == false) System.out .println("There is no solution for
 * the equation group!"); else System.out.println(s.problem.printSolution()); //
 * System.out.println( s.problem.printProblem()); // if
 * (s.problem.solve()==false) System.out.println("There is no // solution for
 * the equation group!"); // else System.out.println(s.problem.printSolution()); } } }
 */
